#! /bin/env python
# test the key module
#
#  $Id: test_key.py,v 1.13 2006/05/19 23:50:35 mwalfish Exp $
# 
#

#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
import dqm.cryptkey_wrap.cryptkey as cryptkey
import random
import os
import sys

if __name__ == "__main__":

    priv = cryptkey.gen_rabin_privkey(1024)
    pub  = priv.to_pubkey()

    pub_str = pub.to_str()
    pub2    = cryptkey.str_to_pubkey(pub_str)

    test_file_priv = "/tmp/testing_priv" + str(random.random())
    test_file_pub  = "/tmp/testing_pub" + str(random.random())

    priv.to_file(test_file_priv)
    priv3 = cryptkey.file_to_privkey(test_file_priv)

    pub2.to_file(test_file_pub)
    pub3  = cryptkey.file_to_pubkey(test_file_pub)

    os.remove(test_file_priv)
    os.remove(test_file_pub)

    # write to read-only-file test
    read_only_file = "/tmp/asf" + str(random.random())
    f = file(read_only_file, "w")
    f.close()
    os.chmod(read_only_file, 0400)

    did_fail = not pub3.to_file(read_only_file)
    
    os.remove(read_only_file)

    def weaktest(key1, key2):
        return key1.to_str() == key2.to_str()

    tests = [(lambda: weaktest(pub,pub2), "to string and back for public?"), 
	     (lambda: weaktest(priv,priv3), "to file and back for private?"),
	     (lambda: weaktest(pub3,pub2), "to file and back for public?"),
	     (lambda: did_fail is True, "write to read-only file fails?")]

    print "about to run tests"

    for test,msg in tests:
	print msg, 
	if not test(): print "FAILED"; sys.exit(1)
	print "passed"

    sys.exit(0)
