#
# Copyright (C) 2005-2006 Michael Walfish
#
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
# 02110-1301, USA.
#
from distutils.core import setup, Extension

module1 = Extension('cryptkey',
    # I _really_ don't like putting the libraries here (the libraries belong
    # in the Makefile), but we have to put the libraries here because
    # the python code that parses the command-line arguments to build_ext has
    # a bug whose result is that only one library can be passed on the
    # command-line.
    libraries     =   ['stdc++', 'arpc','sfscrypt','async','gmp','nsl',
			 'resolv','m','ssl'],
    sources       =   ['cryptkey_wrap.C', 'cryptkey.C'])

setup (name = 'CryptKey', 
    version = '1.0', 
    description = 'This is a Rabin and RSA cryptographic key wrapper', 
    ext_modules = [module1])
