/*
 * Interface for users of DQM like e-mail recipients and e-mail servers.
 * test/set interface.
 */

#ifndef RPCC_P
%#include "dqm_types.h"
#else
%# we have to import into the global namespace because the current module
%# doesn't know where to find the stuff that's declared in dqm_types.
%from dqm_types import *
#endif

struct dqmportal_test_arg {
    dqm_key key;
};

struct dqmportal_set_arg {
    dqm_key key;
    dqm_val val;
    metastamp ms;
};

union dqmportal_test_res switch (dqm_stat status) {
    case DQM_OK:
	dqm_val val;
    case DQM_NOT_FOUND:
	void;
    default:
	void;
};

program DQM_PORTAL_PROGRAM {
    version DQM_PORTAL_VERSION {
	void
	DQM_PORTAL_PROC_NULL (void) = 1;

	dqmportal_test_res
	DQM_PORTAL_PROC_TEST (dqmportal_test_arg) = 2;
   
	dqm_stat
	DQM_PORTAL_PROC_SET (dqmportal_set_arg) = 3;

    } = 1;
} = 23094122;
