/*
 * Interface by which DQM nodes make set and get requests of each other.
 * put/get interface. 
 */

#ifndef RPCC_P
%#include "dqm_types.h"
#else
%from dqm_types import *
#endif

struct dqmstorer_get_arg {
    dqm_key key;
};

struct dqmstorer_put_arg {
    dqm_key key;
    dqm_val val;
    int ttl;
};

union dqmstorer_get_res switch (dqm_stat status) {
    case DQM_OK:
	dqm_val val;
    case DQM_NOT_FOUND:
	void;
    default:
	void;
};

program DQM_STORER_PROGRAM {
    version DQM_STORER_VERSION {

	void
	DQM_STORER_PROC_NULL (void) = 1;

	dqmstorer_get_res
	DQM_STORER_PROC_GET (dqmstorer_get_arg) = 2;

	dqm_stat
	DQM_STORER_PROC_PUT (dqmstorer_put_arg) = 3;

    } = 1;
} = 23094123;
