/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include "async.h"
#include "cryptkey.h"
#include "config.h"
#include "tt.h"

int main(int argc, char** argv)
{
    if (argc != 2) {
	printf("usage: %s key-file\n", argv[0]);
	exit(0);
    }
  
    char dummybuf[800];
    memset(dummybuf, 'a', sizeof(dummybuf));
    str dummy(dummybuf, sizeof(dummybuf));

    ptr<privkey> privk = file_to_privkey(argv[1]);
    if (privk == NULL) 
	fatal << "couldn't open priv key file " << argv[1] << "\n";

    str sig = privk->sign(dummy);

    ptr<pubkey> pubk = privk->to_pubkey();
    time_it t;

    for (int i = 0; i < 1000; i++) {
	t.begin();
	pubk->verify(dummy, sig);
	t.end();
    }
    char d[50];
    sprintf(d, "min: %.3f\n", t.min_us());
    warnx << d << "\n";
    return 0;
}
