
#!/usr/bin/python
# gen-config.py: a dumb script for generating config files for use in experiments
#
# written in python because JD knows it better than bash
# and time is money

import os.path
import getopt
import sys

if __name__ == "__main__":

    def usage():
	print """usage: %s [-d tree_degree] [-t] [-r val] [-l cachesize] [-m mapsize] machine-list dest """\
	       % sys.argv[0]
	sys.exit(1)


    try:  
        opts, args = getopt.getopt(sys.argv[1:], 'd:tr:l:m:')

    except getopt.GetoptError: usage()

    if len(args) != 2: usage()

    tree_degree = "2"
    use_tree = "0"
    r_val = "4"
    lru_cache = "1"
    map_size = "10000000"

    for o,a in opts:
        if o == '-d': tree_degree = a
        if o == '-t': use_tree = "1"
        if o == '-r': r_val = a
        if o == '-l': lru_cache = a
        if o == '-m': map_size = a

    maclist, dest = args

    if not os.path.isfile(maclist):
        print "Could not open machine list %s" % (maclist)
	sys.exit(1)

    if not os.path.isdir(dest):
        print "Destination %s does not exist or is not a directory" % (dest)
        sys.exit(1)

    mfile = file(maclist)

    machines = mfile.readlines()

    path_prefix = "/proj/Spam-I-am/exp/"

    for l in machines:
        nodeinfo = l.split(":")
        short_name = nodeinfo[0].split(".")[0]
        f = file(dest + "/" + nodeinfo[0] + ".config", "w")
        f.write("""# config file for """ + nodeinfo[0] + \
""", generated by gen.py:
# """ + str(sys.argv) + """
#
# a few words about the format:
#   '#' characters indicate comment lines
#    attribute values are separated from the attribute by whitespace
""")
        f.write("key_val_storage  " + "/tmp/" + short_name + "_keyval_dir\n\n")
#        f.write("key_val_storage /dev/sda4\n\n")
        f.write("portal_port      " + nodeinfo[1] + "\n")
        f.write("storer_port      " + nodeinfo[2] + "\n")
        f.write("internal_port    " + nodeinfo[3] + "\n")
        f.write("""
num_rings     50
tree_degree   """ + tree_degree + """
r             """ + r_val + """
use_tree      """ + use_tree + """
cache_entries """ + lru_cache + """
index_entries """ + map_size + """
""")
#        f.write("trusted_signer RABIN_1536_METASTAMP " + signers)
        f.write("\nidentity         " + short_name + "\n\n")

        for m in machines:
            n2 = m.split(":")
            n2_name = n2[0].split(".")[0]
            f.write("storer           " + n2_name + " " + n2[0] + ":" + \
                    n2[2] + ":" + n2[3])

        f.write("""
""")
