# change these for your local setup
SFSPATH         = /usr/local
DMALLOCPATH     = /usr

MY_COMP		?= g++
FLAGS	        = -g -Wall -Werror -fno-exceptions
# need flags for large file support on Linux
# in the world of autoconf, one does AC_SYS_LARGEFILE
CFLAGS          += $(shell getconf LFS_CFLAGS)
LDFLAGS         += $(shell getconf LFS_LDFLAGS)
LIBS            = -larpc -lsfscrypt -lasync 
LIBS_PSH        = $(LIBS:async=asyncpsh)

ifeq ($(mode), optmz)
    SFS_HEADER_PATH = $(SFSPATH)/include/sfslite
    SFS_LIB_PATH    = $(SFSPATH)/lib/sfslite
    FLAGS += -O2
else
ifeq ($(mode), profile)
    SFS_HEADER_PATH = $(SFSPATH)/include/sfslite/profile
    SFS_LIB_PATH    = $(SFSPATH)/lib/sfslite/profile
    FLAGS += -O2 -pg
else
    SFS_HEADER_PATH = $(SFSPATH)/include/sfslite/debug
    SFS_LIB_PATH    = $(SFSPATH)/lib/sfslite/debug
    LIBS += -ldmalloc
endif
endif

TOP_BUILD_DIR := $(shell pwd)/$(PATH_TO_TOP)

HEADER_PATHS = -I$(SFS_HEADER_PATH) -I$(DMALLOCPATH)/include \
               -I$(TOP_BUILD_DIR)/svc -I$(TOP_BUILD_DIR)

LINK_PATHS = -L$(SFS_LIB_PATH) -L$(DMALLOCPATH)/lib

SVC_IN_LOC = $(TOP_BUILD_DIR)/../dqm/svc
SVC_X	   = dqm_portal.x dqm_storer.x dqm_types.x

%.o: %.C
	$(MY_COMP) -c $(HEADER_PATHS) $(FLAGS) $(CFLAGS) -o $@ $<

