/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */
#include <stdio.h>
#include "async.h"
#include "dqm_types.h"
#include "lru_cache.h"

int
main(int argc, char** argv)
{
    //u_int32_t foo = 0xff00ff00;

    lru_cache c(3);
    ptr<dqm_key> key = New refcounted<dqm_key> ();
    ptr<dqm_key> key2 = New refcounted<dqm_key> ();
    ptr<dqm_val> val = New refcounted<dqm_val> ();
    ptr<dqm_val> val2 = New refcounted<dqm_val> ();

    memset(key->base(), 0, key->size());
    memset(key2->base(), 1, key2->size());

    memset(val->base(), 3, val->size());
    memset(val2->base(), 4, val2->size());
 
    kv_rec r1(key, val);
    kv_rec r2(key2, val2);
    kv_rec r3(key, val);

    c.add(&r1);
    c.add(&r2);
    c.add(&r3);
    c.dump();

    kv_rec r0(NULL, NULL);
    delete &r0;
}


#if 0
int
main(int argc, char** argv)
{
    typedef qhash<ptr<dqm_key>, ptr<dqm_val> > map;
    map m;

    ptr<dqm_key> key = New refcounted<dqm_key> ();
    ptr<dqm_key> key2 = New refcounted<dqm_key> ();
    ptr<dqm_val> val = New refcounted<dqm_val> ();
    ptr<dqm_val> val2 = New refcounted<dqm_val> ();

    memset(key->base(), 0, key->size());
    memset(key2->base(), 1, key2->size());

    memset(val->base(), 3, val->size());
    memset(val2->base(), 4, val2->size());
   
    equals<ptr<dqm_key> > e;
    if (e(key,key2)) {
	printf("the two keys are equal\n");
    } else {
	printf("the two keys are not equal\n");
    }

    m.insert(key, val);
    m.insert(key2, val2);

    map::slot* s; 
    for (s = m.first(); s; s = m.next(s)) {
	warnx << "key: " << hexdump(s->key->base(), s->key->size()) << "\n";
	warnx << "val: " << hexdump(s->value->base(), s->value->size()) << "\n";
    }
    return 0;
}
#endif
