/*
 * Copyright (C) 2005-2006 Michael Walfish
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
 * 02110-1301, USA.
 */

#include "async.h"
#include "olist.h"

struct lstelm {
    int foo;
    int bar;
    list_entry<lstelm> link;
    bool operator< (lstelm& other)
    {
	return foo < other.foo;
    }
};

typedef olist<lstelm, &lstelm::link> mylst;

int main(int argc, char** argv)
{
    mylst thelist; 

    lstelm* a = New lstelm;
    lstelm* b = New lstelm;
    lstelm* c = New lstelm;
    lstelm* d = New lstelm;
  
    a->foo = 3;
    b->foo = 1;
    c->foo = 4;
    d->foo = 2;

    thelist.insert(a);
    thelist.insert(b);
    thelist.insert(c);
    thelist.insert(d);

    for (lstelm* curr = thelist.first; curr; curr = thelist.next(curr)) {
	printf("%d\n", curr->foo);
    }

    exit(1);
}
